package cokr.xit.fims.payer.service;

import java.util.List;

import cokr.xit.fims.payer.Payer;
import cokr.xit.fims.payer.PayerQuery;
import cokr.xit.foundation.data.DataObject;
import cokr.xit.interfaces.lvis.v2406.LvisA01;

/**납부자 대장 관리 서비스 인터페이스.
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-18	mjkhan 최초 작성
 * ================================
 * </pre>
 */
public interface PayerService {
	/**지정한 조건에 따라 납부자 대장 목록을 조회하여 반환한다.
	 * @param req 납부자 대장 조회 조건
	 * @return 납부자 대장 목록
	 */
	List<DataObject> getPayerList(PayerQuery req);

	/**지정한 조건에 따라 납부자 대장 객체들을 반환한다.
	 * @param req 납부자 대장 조회 조건
	 * @return 납부자 대장 객체 목록
	 */
	List<Payer> getPayers(PayerQuery req);

	/**납부자 대장 정보를 등록한다.
	 * @param payer 납부자 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	boolean create(Payer payer);

	/**납부자 대장 정보를 수정한다.
	 * @param payer 납부자 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	boolean update(Payer payer);

	/**납부자 주소 정보를 등록한다.
	 * @param payer 납부자 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	boolean createPayerAddr(Payer payer);

	/**납부자 주소 정보를 수정한다.
	 * @param payer 납부자 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	boolean updatePayerAddr(Payer payer);

	/**주어진 조건의 차량 및 소유자(납부자) 정보를 반환한다.
	 * @param req 자동차 기본정보 조회 조건
	 * @return 차량 및 소유자(납부자) 정보
	 */
	Payer findVehicleOwner(LvisA01.A01Request req);

	/**지정한 조건에 따라 납부자 대장 정보를 반환한다.<br />
	 * @param req 납부자 대장 조회 조건
	 * @return 납부자 대장 정보
	 */
	DataObject getCrdnPayerInfo(PayerQuery req);

	/**납부자 대장 정보를 등록한다.
	 * @param payer 납부자 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	String createCrdnPayer(Payer payer);

	/**지정한 조건에 따라 납부자 이력 목록을 조회하여 반환한다.
	 * @param req 납부자 대장 조회 조건
	 * @return 납부자 변경 이력 목록
	 */
	List<DataObject> getPayerHstrys(PayerQuery req);

	/**지정한 조건에 따라 납부자 주소 이력 목록을 조회하여 반환한다.
	 * @param req 납부자 대장 조회 조건
	 * @return 납부자 변경 이력 목록
	 */
	List<DataObject> getPayerAddrHstrys(PayerQuery req);

    /**지정한 조건에 따라 납부자 대장 정보를 반환한다.<br />
     * @param req 납부자 대장 조회 조건
     * @return 납부자 대장 정보
     */
    DataObject getLastPayerAddrInfo(PayerQuery req);
}